<?php

namespace mriConditions\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for GetDiseaseInfoICD10 StructType
 * @subpackage Structs
 */
class GetDiseaseInfoICD10 extends AbstractStructBase
{
    /**
     * The intChannelID
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var int
     */
    public $intChannelID;
    /**
     * The intLanguageId
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var int
     */
    public $intLanguageId;
    /**
     * The intCountryId
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var int
     */
    public $intCountryId;
    /**
     * The intCaptureOne
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var int
     */
    public $intCaptureOne;
    /**
     * The intCaptureTwo
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var int
     */
    public $intCaptureTwo;
    /**
     * The intCaptureThree
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var int
     */
    public $intCaptureThree;
    /**
     * The intCaptureFour
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var int
     */
    public $intCaptureFour;
    /**
     * The intCaptureFive
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var int
     */
    public $intCaptureFive;
    /**
     * The strICD10Chapter
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $strICD10Chapter;
    /**
     * The strICD10Block
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $strICD10Block;
    /**
     * The strWsKey
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $strWsKey;
    /**
     * Constructor method for GetDiseaseInfoICD10
     * @uses GetDiseaseInfoICD10::setIntChannelID()
     * @uses GetDiseaseInfoICD10::setIntLanguageId()
     * @uses GetDiseaseInfoICD10::setIntCountryId()
     * @uses GetDiseaseInfoICD10::setIntCaptureOne()
     * @uses GetDiseaseInfoICD10::setIntCaptureTwo()
     * @uses GetDiseaseInfoICD10::setIntCaptureThree()
     * @uses GetDiseaseInfoICD10::setIntCaptureFour()
     * @uses GetDiseaseInfoICD10::setIntCaptureFive()
     * @uses GetDiseaseInfoICD10::setStrICD10Chapter()
     * @uses GetDiseaseInfoICD10::setStrICD10Block()
     * @uses GetDiseaseInfoICD10::setStrWsKey()
     * @param int $intChannelID
     * @param int $intLanguageId
     * @param int $intCountryId
     * @param int $intCaptureOne
     * @param int $intCaptureTwo
     * @param int $intCaptureThree
     * @param int $intCaptureFour
     * @param int $intCaptureFive
     * @param string $strICD10Chapter
     * @param string $strICD10Block
     * @param string $strWsKey
     */
    public function __construct($intChannelID = null, $intLanguageId = null, $intCountryId = null, $intCaptureOne = null, $intCaptureTwo = null, $intCaptureThree = null, $intCaptureFour = null, $intCaptureFive = null, $strICD10Chapter = null, $strICD10Block = null, $strWsKey = null)
    {
        $this
            ->setIntChannelID($intChannelID)
            ->setIntLanguageId($intLanguageId)
            ->setIntCountryId($intCountryId)
            ->setIntCaptureOne($intCaptureOne)
            ->setIntCaptureTwo($intCaptureTwo)
            ->setIntCaptureThree($intCaptureThree)
            ->setIntCaptureFour($intCaptureFour)
            ->setIntCaptureFive($intCaptureFive)
            ->setStrICD10Chapter($strICD10Chapter)
            ->setStrICD10Block($strICD10Block)
            ->setStrWsKey($strWsKey);
    }
    /**
     * Get intChannelID value
     * @return int
     */
    public function getIntChannelID()
    {
        return $this->intChannelID;
    }
    /**
     * Set intChannelID value
     * @param int $intChannelID
     * @return \mriConditions\StructType\GetDiseaseInfoICD10
     */
    public function setIntChannelID($intChannelID = null)
    {
        // validation for constraint: int
        if (!is_null($intChannelID) && !(is_int($intChannelID) || ctype_digit($intChannelID))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($intChannelID, true), gettype($intChannelID)), __LINE__);
        }
        $this->intChannelID = $intChannelID;
        return $this;
    }
    /**
     * Get intLanguageId value
     * @return int
     */
    public function getIntLanguageId()
    {
        return $this->intLanguageId;
    }
    /**
     * Set intLanguageId value
     * @param int $intLanguageId
     * @return \mriConditions\StructType\GetDiseaseInfoICD10
     */
    public function setIntLanguageId($intLanguageId = null)
    {
        // validation for constraint: int
        if (!is_null($intLanguageId) && !(is_int($intLanguageId) || ctype_digit($intLanguageId))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($intLanguageId, true), gettype($intLanguageId)), __LINE__);
        }
        $this->intLanguageId = $intLanguageId;
        return $this;
    }
    /**
     * Get intCountryId value
     * @return int
     */
    public function getIntCountryId()
    {
        return $this->intCountryId;
    }
    /**
     * Set intCountryId value
     * @param int $intCountryId
     * @return \mriConditions\StructType\GetDiseaseInfoICD10
     */
    public function setIntCountryId($intCountryId = null)
    {
        // validation for constraint: int
        if (!is_null($intCountryId) && !(is_int($intCountryId) || ctype_digit($intCountryId))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($intCountryId, true), gettype($intCountryId)), __LINE__);
        }
        $this->intCountryId = $intCountryId;
        return $this;
    }
    /**
     * Get intCaptureOne value
     * @return int
     */
    public function getIntCaptureOne()
    {
        return $this->intCaptureOne;
    }
    /**
     * Set intCaptureOne value
     * @param int $intCaptureOne
     * @return \mriConditions\StructType\GetDiseaseInfoICD10
     */
    public function setIntCaptureOne($intCaptureOne = null)
    {
        // validation for constraint: int
        if (!is_null($intCaptureOne) && !(is_int($intCaptureOne) || ctype_digit($intCaptureOne))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($intCaptureOne, true), gettype($intCaptureOne)), __LINE__);
        }
        $this->intCaptureOne = $intCaptureOne;
        return $this;
    }
    /**
     * Get intCaptureTwo value
     * @return int
     */
    public function getIntCaptureTwo()
    {
        return $this->intCaptureTwo;
    }
    /**
     * Set intCaptureTwo value
     * @param int $intCaptureTwo
     * @return \mriConditions\StructType\GetDiseaseInfoICD10
     */
    public function setIntCaptureTwo($intCaptureTwo = null)
    {
        // validation for constraint: int
        if (!is_null($intCaptureTwo) && !(is_int($intCaptureTwo) || ctype_digit($intCaptureTwo))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($intCaptureTwo, true), gettype($intCaptureTwo)), __LINE__);
        }
        $this->intCaptureTwo = $intCaptureTwo;
        return $this;
    }
    /**
     * Get intCaptureThree value
     * @return int
     */
    public function getIntCaptureThree()
    {
        return $this->intCaptureThree;
    }
    /**
     * Set intCaptureThree value
     * @param int $intCaptureThree
     * @return \mriConditions\StructType\GetDiseaseInfoICD10
     */
    public function setIntCaptureThree($intCaptureThree = null)
    {
        // validation for constraint: int
        if (!is_null($intCaptureThree) && !(is_int($intCaptureThree) || ctype_digit($intCaptureThree))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($intCaptureThree, true), gettype($intCaptureThree)), __LINE__);
        }
        $this->intCaptureThree = $intCaptureThree;
        return $this;
    }
    /**
     * Get intCaptureFour value
     * @return int
     */
    public function getIntCaptureFour()
    {
        return $this->intCaptureFour;
    }
    /**
     * Set intCaptureFour value
     * @param int $intCaptureFour
     * @return \mriConditions\StructType\GetDiseaseInfoICD10
     */
    public function setIntCaptureFour($intCaptureFour = null)
    {
        // validation for constraint: int
        if (!is_null($intCaptureFour) && !(is_int($intCaptureFour) || ctype_digit($intCaptureFour))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($intCaptureFour, true), gettype($intCaptureFour)), __LINE__);
        }
        $this->intCaptureFour = $intCaptureFour;
        return $this;
    }
    /**
     * Get intCaptureFive value
     * @return int
     */
    public function getIntCaptureFive()
    {
        return $this->intCaptureFive;
    }
    /**
     * Set intCaptureFive value
     * @param int $intCaptureFive
     * @return \mriConditions\StructType\GetDiseaseInfoICD10
     */
    public function setIntCaptureFive($intCaptureFive = null)
    {
        // validation for constraint: int
        if (!is_null($intCaptureFive) && !(is_int($intCaptureFive) || ctype_digit($intCaptureFive))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($intCaptureFive, true), gettype($intCaptureFive)), __LINE__);
        }
        $this->intCaptureFive = $intCaptureFive;
        return $this;
    }
    /**
     * Get strICD10Chapter value
     * @return string|null
     */
    public function getStrICD10Chapter()
    {
        return $this->strICD10Chapter;
    }
    /**
     * Set strICD10Chapter value
     * @param string $strICD10Chapter
     * @return \mriConditions\StructType\GetDiseaseInfoICD10
     */
    public function setStrICD10Chapter($strICD10Chapter = null)
    {
        // validation for constraint: string
        if (!is_null($strICD10Chapter) && !is_string($strICD10Chapter)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($strICD10Chapter, true), gettype($strICD10Chapter)), __LINE__);
        }
        $this->strICD10Chapter = $strICD10Chapter;
        return $this;
    }
    /**
     * Get strICD10Block value
     * @return string|null
     */
    public function getStrICD10Block()
    {
        return $this->strICD10Block;
    }
    /**
     * Set strICD10Block value
     * @param string $strICD10Block
     * @return \mriConditions\StructType\GetDiseaseInfoICD10
     */
    public function setStrICD10Block($strICD10Block = null)
    {
        // validation for constraint: string
        if (!is_null($strICD10Block) && !is_string($strICD10Block)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($strICD10Block, true), gettype($strICD10Block)), __LINE__);
        }
        $this->strICD10Block = $strICD10Block;
        return $this;
    }
    /**
     * Get strWsKey value
     * @return string|null
     */
    public function getStrWsKey()
    {
        return $this->strWsKey;
    }
    /**
     * Set strWsKey value
     * @param string $strWsKey
     * @return \mriConditions\StructType\GetDiseaseInfoICD10
     */
    public function setStrWsKey($strWsKey = null)
    {
        // validation for constraint: string
        if (!is_null($strWsKey) && !is_string($strWsKey)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($strWsKey, true), gettype($strWsKey)), __LINE__);
        }
        $this->strWsKey = $strWsKey;
        return $this;
    }
}
